<template>
    <div>
        <material-button
            @click="onClick"
            :styles="['mdc-button--outlined']"
        >
            Create dictionary
        </material-button>
        <material-dialog
            id="create-dictionary-dialog"
            @closing="hideDialog()"
            :show="show"
            header="Create new dictionary"
        >
            <template v-slot:actions>
                <material-button
                    :styles="['mdc-dialog__button', 'mdc-button--outlined']"
                    @click="onSave"
                    :disabled="dictionaryName.length === 0"
                    data-mdc-dialog-action="save"
                >Save</material-button>
                <material-button
                    :styles="['mdc-dialog__button', 'mdc-button--outlined']"
                    data-mdc-dialog-action="cancel"
                >Cancel</material-button>
            </template>

            <material-field
                class="create-dictionary__input"
                placeholder="Name..."
                v-model="dictionaryName"
                @keypress.enter="onSave"
            />
        </material-dialog>
    </div>
</template>
<script>
export default {
    data() {
        return {
            show: false,
            dictionaryName: '',
        };
    },
    methods: {
        hideDialog() {
            this.show = false;
        },
        onClick() {
            this.show = true;
        },
        onSave() {
            axios.post('dictionaries', {
                name: this.dictionaryName,
            })
            .then(response => {
                this.dictionaryName = '';
                this.hideDialog();

                this.$toasted.show('Dictionary created', {
                    icon: 'check-circle',
                });

                this.$emit('dictionary-created', response.data);
            })
            .catch(error => {
                this.$toasted.global.apiError(error);
            });
        },
    },
};
</script>
<style>
.create-dictionary__input {
    height: 36px;
}
</style>
